﻿using System;
using System.Collections.Generic;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using Telerik.Web.UI.ImageEditor;

public partial class ImageEditor : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		RadImageEditor1.ImageSaving+=RadImageEditor1_ImageSaving;
	}

	protected void AsyncUpload1_FileUploaded(object sender, FileUploadedEventArgs e)
	{
		//Clear changes and remove uploaded image from Cache
		RadImageEditor1.ResetChanges();
		Context.Cache.Remove(Session.SessionID + "UploadedFile");
		using (Stream stream = e.File.InputStream)
		{
			byte[] imgData = new byte[stream.Length];
			stream.Read(imgData, 0, imgData.Length);
			MemoryStream ms = new MemoryStream();
			ms.Write(imgData, 0, imgData.Length);

			Context.Cache.Insert(Session.SessionID + "UploadedFile", ms, null, DateTime.Now.AddMinutes(20), TimeSpan.Zero);
		}
	}

	protected void RadImageEditor1_ImageSaving(object sender, ImageEditorSavingEventArgs e)
	{
		string sFullPath = Server.MapPath("~/Uploads/");
		string sFileName = "testImage" + DateTime.Now.Ticks;
		string sExt = ".gif";
		string sThumbName = sFileName + "_thumb";
		Telerik.Web.UI.ImageEditor.EditableImage img = e.Image;

		if (img.Width > 600 && img.Height > 600)
			img.Resize(600, 600);
		img.Image.Save(sFullPath + sFileName + sExt);

		if (img.Width > 150 && img.Height > 150)
			img.Resize(150, 150);
		img.Image.Save(sFullPath + sThumbName + sExt);
		
		e.Cancel = true;
	}

	protected void RadImageEditor1_ImageLoading(object sender, ImageEditorLoadingEventArgs args)
	{
		//Handle Uploaded images
		if (!Object.Equals(Context.Cache.Get(Session.SessionID + "UploadedFile"), null))
		{
			using (EditableImage image = new EditableImage((MemoryStream)Context.Cache.Remove(Session.SessionID + "UploadedFile")))
			{
				args.Image = image.Clone();
				args.Cancel = true;
			}
		}
	}
}